English Amiga Board

English Amiga Board (http://eab.abime.net/index.php)
-   support.FS-UAE (http://eab.abime.net/forumdisplay.php?f=122)
-   -   PPC Support in FS-UAE (http://eab.abime.net/showthread.php?t=75132)

FrodeSolheim 17 September 2014 22:16

PPC Support in FS-UAE
 
2 Attachment(s)
With the release of FS-UAE 2.5.15dev, PPC accelerators are now emulated with the help of the newly developed qemu-uae plugin. Using this plugin allows you to emulate a CyberStorm PPC accelerator, and run (among other things) AmigaOS 4.1 classic.

FS-UAE has two new models for easy configuration:
  • A4000/PPC - an A4000 with 68060 and a 128 MB CyberStorm PPC accelerator added. Intended for use with AmigaOS 3.x + PPC (WarpOS, PowerUp).
  • A4000/OS4 - same as above, but also with Picasso IV pre-configured + some other options set. For example the default controller for HDFs and CD drives is on-board SCSI. Ideal for use with AmigaOS 4.x classic.
(These models are still subject to change if there's a slightly good reason for it...)

When using CyberStorm PPC (accelerator = cyberstorm-ppc or automatically enabled by above models), you need to have cyberstormppc.rom in the Kickstarts folder (yes, the directory should be called "ROMs" now, really...) - or - you can manually specify the path with the accelerator_rom option.

When you use Picasso IV (graphics_card = picasso-iv, or enabled automatically by A4000/0S4), you need to have the correct Picasso IV ROM file in the Kickstarts folder and/or indexed by the FS-UAE Launcher file scanner. The (zipped) ROM file can be found here: http://www.sophisticated-development...V&section=P-IV (PIV_FlashImage74.zip).

The qemu-uae plugin is available now for Windows and Mac OS X. For Linux, you need to compile it yourself at this point.

Due to the similarity between FS-UAE and WinUAE (and they use the same qemu-uae library), the WinUAE QEMU PPC thread is also largely relevant for FS-UAE users.

Known Issues
  • The PearPC fallback (when qemu-uae is not found or cannot be loaded) may not work properly right now. Please make sure you are using the qemu-uae plugin (check in fs-uae.log.txt that it is loaded properly) if you’re having problems.
  • AmigaOS 4.1 w/Picasso IV => sometimes weird frame rate (~36 FPS).
  • When starting FS-UAE from FS-UAE Launcher, accelerator flashs ROM writes are not persistent because the launcher uses a new copy every time.

FrodeSolheim 17 September 2014 22:24

Example configuration file which is sufficient to run the AmigaOS 4.1 installer (provided FS-UAE also finds the required ROMs):
Code:

[fs-uae]
amiga-model = A4000/OS4
floppy_drive_0 = AmigaOS4.1.adf
hard_drive_0 = AmigaOS4.1.hdf
cdrom_drive_0 = AmigaOS4.1.iso


amigafreak68k 18 September 2014 16:56

1 Attachment(s)
It seems there is something missing. FS-UAE crashes with immediately

Code:

DLOPEN: dlopen(/Volumes/Data/AMIGA/FS-UAE (Executable)/Plugins/qemu-uae-macosx-x86/2.1.0fs020000/qemu-uae.so, 2): Library not loaded: /usr/local/i686-apple-darwin10/lib/libgthread-2.0.0.dylib
  Referenced from: /Volumes/Data/AMIGA/FS-UAE (Executable)/Plugins/qemu-uae-macosx-x86/2.1.0fs020000/qemu-uae.so
  Reason: Incompatible library version: qemu-uae.so requires version 3801.0.0 or later, but libgthread-2.0.0.dylib provides version 3303.0.0

I'd copied the dylib from /usr/local/lib but it seems too old

FrodeSolheim 18 September 2014 18:09

Ah yes, this is what happens when one only tests on the same computer where it is compiled. Your information is sufficient to understand the problem, I'll post here once I've got a fixed plugin :)

amigafreak68k 18 September 2014 18:11

I had offered me twice as a tester :)

amigafreak68k 18 September 2014 18:18

BTW: PearPC fallback seems to work, but not with AmigaOS4.

I'd tested with AmigaOS 3.9 and WarpOS. I get the error message about the missing plugin but could execute PPC binaries

amigafreak68k 18 September 2014 18:35

Quote:

Originally Posted by FrodeSolheim (Post 976371)
Known Issues
  • When starting FS-UAE from FS-UAE Launcher, accelerator flashs ROM writes are not persistent because the launcher uses a new copy every time.

How to prevent this?

A user in the WinUAE thread wrote, that with setting the flash to boot from CDROM makes a boot floppy obsolete, because the Amiga OS 4.1 CDROM is bootable.

FrodeSolheim 18 September 2014 18:41

Quote:

Originally Posted by amigafreak68k (Post 976504)
How to prevent this?

A user in the WinUAE thread wrote, that with setting the flash to boot from CDROM makes a boot floppy obsolete, because the Amiga OS 4.1 CDROM is bootable.

For now:
1. You can just change the setting and reset the emulator, the modifications won't be gone until you start FS-UAE again from FS-UAE Launcher,
2. Or start FS-UAE directly without going through the Launcher (double-click the .fs-uae file in Finder, etc)

amigafreak68k 18 September 2014 18:52

Makes it sence to specify the ROM with the "uae_" options like in the previous versions?

Are you sure, that nothing is saved? I'd make a change in the SCSI setting to disable Unit 3. This setting is present after I restart Launcher

FrodeSolheim 18 September 2014 19:11

Quote:

Originally Posted by amigafreak68k (Post 976496)
I had offered me twice as a tester :)

I had to make some modifications to both FS-UAE and QEMU-UAE builds so the latter can properly reference libraries from the former (on OS X). You are now called upon to help testing :)
No reason for Windows users to update!

(And yes, the PearPC issue is consistent with my experience, which is why I added the known issues-bit)

amigafreak68k 18 September 2014 19:32

AmigaOS 4.1 installation in progress right now :)

jbl007 18 September 2014 19:39

Quote:

Originally Posted by FrodeSolheim (Post 976371)
For Linux, you need to compile it yourself at this point.

Stops at this point:
Code:

cc -I/home/stw/src/qemu-uae/tcg -I/home/stw/src/qemu-uae/tcg/i386 -I/home/stw/src/qemu-uae/linux-headers -I/home/stw/src/qemu-uae/linux-headers -I. -I/home/stw/src/qemu-uae -I/home/stw/src/qemu-uae/include -I. -I. -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -Wstrict-prototypes -Wredundant-decls -Wall -Wundef -Wwrite-strings -Wmissing-prototypes -fno-strict-aliasing -fno-common  -Wendif-labels -Wmissing-include-dirs -Wempty-body -Wnested-externs -Wformat-security -Wformat-y2k -Winit-self -Wignored-qualifiers -Wold-style-declaration -Wold-style-definition -Wtype-limits  -I/usr/include/pixman-1  -I/home/stw/src/qemu-uae/dtc/libfdt -I/home/stw/src/qemu-uae/../src/include -I/home/stw/src/qemu-uae/../include -Wno-missing-include-dirs -I/home/stw/src/qemu-uae/tests -MMD -MP -MT qemu-log.o -MF ./qemu-log.d -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -pthread -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include  -g -fPIC -DDEBUG_UNASSIGNED -DQEMU_UAE  -c -o qemu-log.o qemu-log.c
qemu-log.c:24:21: fatal error: uae/log.h: No such file or directory
 #include "uae/log.h"
                    ^
compilation terminated.
/home/stw/src/qemu-uae/rules.mak:32: recipe for target 'qemu-log.o' failed
make: *** [qemu-log.o] Error 1

Edit: Symlinked qemu-uae/include/qemu/log.h to uae/log.h, and now uae/ppc.h is missing. I don't give up. :D
Edit2: Symlinked qemu-uae/include/hw/ppc/ppc.h to uae/ppc.h, now got errors in uae/qemu-uae-cpu.c.
I give up now, just linking files at random without any knowledge seems to be a bad idea.

amigafreak68k 18 September 2014 19:43

2 Attachment(s)
...ready... :D

jbl007 18 September 2014 19:52

Quote:

Originally Posted by amigafreak68k (Post 976518)
...ready... :D

Congrats! :cool

FrodeSolheim 18 September 2014 23:36

Quote:

Originally Posted by jbl007 (Post 976517)
qemu-log.c:24:21: fatal error: uae/log.h: No such file or directory

Yes, right, I forgot to mention that qemu-uae should be a sub-dir of fs-uae in order to compile sucessfully (qemu-uae refers to some header files from fs-uae)!

Quote:

Originally Posted by amigafreak68k (Post 976518)
...ready... :D

Great, thanks for testing :)

FrodeSolheim 19 September 2014 00:12

Quote:

Originally Posted by FrodeSolheim (Post 976561)
Yes, right, I forgot to mention that qemu-uae should be a sub-dir of fs-uae in order to compile sucessfully (qemu-uae refers to some header files from fs-uae)!

Actually, I just pushed a commit which changes this so qemu-uae instead must be placed *alongside* fs-uae when compiling. This also fixes an issue where the pixman submodule fails to configure properly due to a missing ltmain.sh script.

jbl007 19 September 2014 20:52

Ok, 64bit version builds just fine now, but still I have some trouble cross-compiling for 32bit (again) :rolleyes
What should I use as a version number? I assume I'll need it for a valid plugin.ini

FrodeSolheim 19 September 2014 21:18

Quote:

Originally Posted by jbl007 (Post 976671)
What should I use as a version number? I assume I'll need it for a valid plugin.ini

Any will do, but I suggest a low one (e.g. 1.0.0) so any future automatic update system will not be confused. Here's a valid plugin ini for Linux x86-64:

Code:

[plugin]
version = 1.0.0

[linux-x86-64]
libqemu-uae = qemu-uae.so


jbl007 19 September 2014 22:45

Qemu-uae ppc up and running now. :great

Config with quickstart model A4000/PPC does not detect my cyberstormppc_44.71.rom (renamed to cyberstormppc.rom) Had to set in manually. Turbo floppy is always enabled for this model, bug or feature? :)

FrodeSolheim 19 September 2014 22:50

Quote:

Originally Posted by jbl007 (Post 976691)
Config with quickstart model A4000/PPC does not detect my cyberstormppc_44.71.rom (renamed to cyberstormppc.rom) Had to set in manually.

Did you put it in the Kickstarts directory? It works here...

Quote:

Originally Posted by jbl007 (Post 976691)
Turbo floppy is always enabled for this model, bug or feature? :)

"Feature" :) (It has always been like that, an inheritance from the (Win)UAe quickstart the A4000 models are based on)


All times are GMT +2. The time now is 15:05.

Powered by vBulletin® Version 3.8.11
Copyright ©2000 - 2020, vBulletin Solutions Inc.

Page generated in 0.05283 seconds with 11 queries